searchData={"items":[{"type":"module","title":"IncidentIo","doc":"","ref":"IncidentIo.html"},{"type":"function","title":"IncidentIo.add_params_to_url/2","doc":"Take an existing URI and add addition params, appending and replacing as necessary.","ref":"IncidentIo.html#add_params_to_url/2"},{"type":"function","title":"Examples - IncidentIo.add_params_to_url/2","doc":"iex> add_params_to_url(\"http://example.com/wat\", [])\n    \"http://example.com/wat\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", [q: 1])\n    \"http://example.com/wat?q=1\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", [q: 1, t: 2])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat\", %{q: 1, t: 2})\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&t=2\", [])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1\", [t: 2])\n    \"http://example.com/wat?q=1&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1\", [q: 3, t: 2])\n    \"http://example.com/wat?q=3&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", [q: 3, t: 2])\n    \"http://example.com/wat?q=3&s=4&t=2\"\n\n    iex> add_params_to_url(\"http://example.com/wat?q=1&s=4\", %{q: 3, t: 2})\n    \"http://example.com/wat?q=3&s=4&t=2\"","ref":"IncidentIo.html#add_params_to_url/2-examples"},{"type":"function","title":"IncidentIo.authorization_header/1","doc":"Same as `authorization_header/2` but defaults initial headers to include `@user_agent`.","ref":"IncidentIo.html#authorization_header/1"},{"type":"function","title":"IncidentIo.authorization_header/2","doc":"Use a JWT bearer token to authenticate to the Incident.io API:","ref":"IncidentIo.html#authorization_header/2"},{"type":"function","title":"Examples - IncidentIo.authorization_header/2","doc":"iex> IncidentIo.authorization_header(%{api_key: \"92873971893\"}, [])\n    [{\"Authorization\", \"Bearer 92873971893\"}]\n\nMore info at: https://api-docs.incident.io/#section/Making-requests/Authentication","ref":"IncidentIo.html#authorization_header/2-examples"},{"type":"function","title":"IncidentIo.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#delete/3"},{"type":"function","title":"IncidentIo.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#delete!/3"},{"type":"function","title":"IncidentIo.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#get/3"},{"type":"function","title":"IncidentIo.get/4","doc":"Underlying utility retrieval function. The options passed affect both the\nreturn value and the number of requests made to Incident.io.","ref":"IncidentIo.html#get/4"},{"type":"function","title":"Options - IncidentIo.get/4","doc":"* `:pagination` - Can be `:none`, `:manual`, `:stream`, or `:auto`. Defaults to :auto.\n\n      - `:none` will only return the first page. You won't have access to the\n        headers to manually paginate.\n\n      - `:auto` will block until all the pages have been retrieved and\n        concatenated together. Most of the time, this is what you want.\n\n      - `:stream` will return a `Stream`, prepopulated with the first page.\n\n      - `:manual` will return a 3 element tuple of `{page_body,\n        url_for_next_page, auth_credentials}`, which will allow you to control\n        the paging yourself.","ref":"IncidentIo.html#get/4-options"},{"type":"function","title":"IncidentIo.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#get!/3"},{"type":"function","title":"IncidentIo.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#head/3"},{"type":"function","title":"IncidentIo.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#head!/3"},{"type":"function","title":"IncidentIo.json_request/5","doc":"","ref":"IncidentIo.html#json_request/5"},{"type":"function","title":"IncidentIo.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#options/3"},{"type":"function","title":"IncidentIo.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#options!/3"},{"type":"function","title":"IncidentIo.patch/3","doc":"","ref":"IncidentIo.html#patch/3"},{"type":"function","title":"IncidentIo.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#patch/4"},{"type":"function","title":"IncidentIo.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#patch!/4"},{"type":"function","title":"IncidentIo.post/3","doc":"","ref":"IncidentIo.html#post/3"},{"type":"function","title":"IncidentIo.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#post/4"},{"type":"function","title":"IncidentIo.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#post!/4"},{"type":"function","title":"IncidentIo.process_headers/1","doc":"","ref":"IncidentIo.html#process_headers/1"},{"type":"function","title":"IncidentIo.process_request_body/1","doc":"","ref":"IncidentIo.html#process_request_body/1"},{"type":"function","title":"IncidentIo.process_request_headers/1","doc":"","ref":"IncidentIo.html#process_request_headers/1"},{"type":"function","title":"IncidentIo.process_request_options/1","doc":"","ref":"IncidentIo.html#process_request_options/1"},{"type":"function","title":"IncidentIo.process_request_params/1","doc":"","ref":"IncidentIo.html#process_request_params/1"},{"type":"function","title":"IncidentIo.process_request_url/1","doc":"","ref":"IncidentIo.html#process_request_url/1"},{"type":"function","title":"IncidentIo.process_response/1","doc":"","ref":"IncidentIo.html#process_response/1"},{"type":"function","title":"IncidentIo.process_response_body/1","doc":"","ref":"IncidentIo.html#process_response_body/1"},{"type":"function","title":"IncidentIo.process_response_chunk/1","doc":"","ref":"IncidentIo.html#process_response_chunk/1"},{"type":"function","title":"IncidentIo.process_response_headers/1","doc":"","ref":"IncidentIo.html#process_response_headers/1"},{"type":"function","title":"IncidentIo.process_response_status_code/1","doc":"","ref":"IncidentIo.html#process_response_status_code/1"},{"type":"function","title":"IncidentIo.process_status_code/1","doc":"","ref":"IncidentIo.html#process_status_code/1"},{"type":"function","title":"IncidentIo.process_url/1","doc":"","ref":"IncidentIo.html#process_url/1"},{"type":"function","title":"IncidentIo.put/3","doc":"","ref":"IncidentIo.html#put/3"},{"type":"function","title":"IncidentIo.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"IncidentIo.html#put/4"},{"type":"function","title":"IncidentIo.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#put!/4"},{"type":"function","title":"IncidentIo.raw_request/5","doc":"","ref":"IncidentIo.html#raw_request/5"},{"type":"function","title":"IncidentIo.request/1","doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"IncidentIo.html#request/1"},{"type":"function","title":"Redirect handling - IncidentIo.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"IncidentIo.html#request/1-redirect-handling"},{"type":"function","title":"Examples - IncidentIo.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"IncidentIo.html#request/1-examples"},{"type":"function","title":"IncidentIo.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"IncidentIo.html#request/5"},{"type":"function","title":"Redirect handling - IncidentIo.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"IncidentIo.html#request/5-redirect-handling"},{"type":"function","title":"Examples - IncidentIo.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"IncidentIo.html#request/5-examples"},{"type":"function","title":"IncidentIo.request!/1","doc":"Issues an HTTP request an `HTTPoison.Request` struct.\nexception in case of failure.\n\n`request!/1` works exactly like `request/1` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"IncidentIo.html#request!/1"},{"type":"function","title":"IncidentIo.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"IncidentIo.html#request!/5"},{"type":"function","title":"IncidentIo.request_stream/5","doc":"","ref":"IncidentIo.html#request_stream/5"},{"type":"function","title":"IncidentIo.request_with_pagination/4","doc":"","ref":"IncidentIo.html#request_with_pagination/4"},{"type":"function","title":"IncidentIo.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"IncidentIo.html#start/0"},{"type":"function","title":"IncidentIo.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"IncidentIo.html#stream_next/1"},{"type":"type","title":"IncidentIo.body/0","doc":"","ref":"IncidentIo.html#t:body/0"},{"type":"type","title":"IncidentIo.headers/0","doc":"","ref":"IncidentIo.html#t:headers/0"},{"type":"type","title":"IncidentIo.method/0","doc":"","ref":"IncidentIo.html#t:method/0"},{"type":"type","title":"IncidentIo.options/0","doc":"","ref":"IncidentIo.html#t:options/0"},{"type":"type","title":"IncidentIo.pagination_response/0","doc":"","ref":"IncidentIo.html#t:pagination_response/0"},{"type":"type","title":"IncidentIo.params/0","doc":"","ref":"IncidentIo.html#t:params/0"},{"type":"type","title":"IncidentIo.request/0","doc":"","ref":"IncidentIo.html#t:request/0"},{"type":"type","title":"IncidentIo.response/0","doc":"","ref":"IncidentIo.html#t:response/0"},{"type":"type","title":"IncidentIo.url/0","doc":"","ref":"IncidentIo.html#t:url/0"},{"type":"module","title":"IncidentIo.Client","doc":"","ref":"IncidentIo.Client.html"},{"type":"function","title":"IncidentIo.Client.new/0","doc":"","ref":"IncidentIo.Client.html#new/0"},{"type":"function","title":"IncidentIo.Client.new/1","doc":"","ref":"IncidentIo.Client.html#new/1"},{"type":"function","title":"IncidentIo.Client.new/2","doc":"","ref":"IncidentIo.Client.html#new/2"},{"type":"type","title":"IncidentIo.Client.auth/0","doc":"","ref":"IncidentIo.Client.html#t:auth/0"},{"type":"type","title":"IncidentIo.Client.t/0","doc":"","ref":"IncidentIo.Client.html#t:t/0"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2024 Sasha Gerrand\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# ex_incident_io\n\nAn Elixir client for the incident.io API.","ref":"readme.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}